<template>
  <div
    class="select-executor-table"
  >
    <div
      v-if="value"
      class="cancel-executor-block"
    >
      <i class="icon alert" />
      <p>Для выбора или ввода вручную нового исполнителяи необходимо сначала <span class="link-style" @click="$emit('on-cancel-executor')">отменить назначение текущего исполнителя</span>, с которым уже подписана заявка. </p>
    </div>
    <ObTable
      ref="table"
      :items="currentExecutors"
      :columns="columns"
      :selected="{}"
      :functional-panel="false"
      :is-smart-pagination="false"
      data-qa="selectExecutorTableModal"
    >
      <div
        slot="select"
        slot-scope="{ data }"
      >
        <template v-if="!data.item.isDisabled">
          <template v-if="value && data.item.uuid === value.uuid">
            <button
              class="cancel-executor-button"
              @click="$emit('on-cancel-executor')"
            >
              <i class="icon close" />
            </button>
          </template>
          <template v-else-if="!value">
            <ObButton
              label="Назначить"
              :mini="true"
              data-qa="btnAppoint"
              @click="selectExecutor(data)"
            />
          </template>
        </template>
      </div>
      <div
        slot="executor"
        slot-scope="{ data }"
        :class="{
          '--disabled': data.item.isDisabled
        }"
      >
        <div>{{ data.item.title }}</div>
        <template v-if="data.item.executorName">
          <div class="participant-name">{{ data.item.executorName }}</div>
        </template>
        <template v-if="data.item.executorInn">
          <div class="participant-name">{{ data.item.executorInn }}</div>
        </template>
        <template v-if="data.item.isBooking">
          <div class="participant-booking">
            <svg width="11" height="10" viewBox="0 0 11 10" fill="none" xmlns="http://www.w3.org/2000/svg">
              <path fill-rule="evenodd" clip-rule="evenodd" d="M10.6332 0.199103C11.0469 0.51997 11.1219 1.11511 10.8007 1.52839L4.50181 9.63362C4.33179 9.85239 4.07446 9.98587 3.79753 9.99894C3.52061 10.012 3.25182 9.90336 3.06192 9.70157L0.257407 6.72153C-0.101332 6.34034 -0.0828355 5.74079 0.29872 5.38239C0.680276 5.024 1.2804 5.04248 1.63914 5.42367L3.68394 7.59643L9.30266 0.366428C9.62384 -0.0468497 10.2195 -0.121764 10.6332 0.199103Z" fill="#10CF96"/>
            </svg>
            <span>букинг запрос подтвержден</span>
          </div>
        </template>
        <template v-if="data.item.isAuction">
          <div class="participant-auction">победитель аукциона</div>
        </template>
      </div>
    </ObTable>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import ObTable from 'common-components/src/obComponents/obTable'
import ObButton from 'common-components/src/obComponents/obButton'
import { formatNumber } from 'common-components/src/helpers/common'
import api from '@/api'
import moment from 'moment'

export default {
  components: {
    ObTable,
    ObButton
  },
  props: {
    value: {
      type: Object,
      default: null
    }
  },
  data () {
    return {
      executors: []
    }
  },
  mounted () {
    this.loadData()
  },
  computed: {
    ...mapGetters({
      bookingExecutors: 'order/participantsConfirmedBooking',
      auctionWinner: 'order/participantWinnerAuction',
      selectedSubOrder: 'order/selectedSubOrder'
    }),
    columns() {
      return [
        {
          title: 'Перевозчик',
          key: 'title',
          slotName: 'executor',
          width: 250,
        },
        {
          title: `Группа риска`,
          key: 'icon',
          width: 100,
          html: (data) => `<i class="icon ${data.icon}" style="font-size: 22px;"></i>`
        },
        {
          title: 'Тариф',
          key: 'tripTariff',
          width: 200,
          html: (data) => `<div class="tariff-cell">
                            <span>${formatNumber(data.tripTariff / 100, { dot: 2 })} ₽</span>
                            <span class="tariff-cell__desc -gray-window">${(data.isVatPayer || data.vatPayer) ? 'тариф с ндс' : 'тариф без ндс'}</span>
                          </div>`
        },
        {
          title: 'Дата отгрузки',
          key: 'status',
          width: 100,
          html: ({ executorLoadingDate }) => executorLoadingDate ? moment(executorLoadingDate).format('DD.MM.yy') : '-'
        },
        {
          title: '',
          sortDisable: true,
          slotName: 'select'
        }
      ]
    },
    currentExecutors () {
      let result = [ ...this.executors ]
      if (this.bookingExecutors.length) {
        result = result.map((item) => {
          return {
            ...item,
            isBooking: Boolean(this.bookingExecutors.find(bookingItem => item.uuid === bookingItem.uuid))
          }
        })
      }
      if (this.auctionWinner) {
        result.unshift({ isAuction: true, ...this.auctionWinner })
      }

      return result
    }},
  methods: {
    selectExecutor (data) {
      this.$emit('on-select', data.item)
    },
    async loadData () {
      try {
        let list = await api.orderProcess.getExecutorsList({ uuid: this.selectedSubOrder.uuid })
        this.executors = list
      } catch (e) {
        this.executors = []
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';
@import '~common-components/src/static/css/mixins';

.max-width-100 {
  max-width: 100%;
}

.color-red {
  color: $light-raspberry-red;
}

.color-green {
  color: $color-green-light;
}

.color-gray {
  color: $color-grey-span;
}

.text-small {
  font-size: 12px;
  line-height: 20px;
}

.text-right {
  text-align: right;
}
</style>

<style lang="scss">
  @import '~common-components/src/static/css/variables';
  @import '~common-components/src/static/css/mixins';

  .select-executor-table {
    &:before {
      display: none !important;
    }
    table {
      min-width: auto!important;
    }
    .table-panel-inner {
      border-left: 1px solid $lavender;
      border-right: 1px solid $lavender;
      border-radius: 3px;
    }
    .table-footer {
      display: none;
    }
    .tariff-cell {
      display: flex;
      flex-direction: column;
      align-items: flex-end;
      @include font-mixin(14px, 18px, 600, $color-text-base, 0.2px);
      &__desc {
        padding-top: 5px;
        font-size: 0.75em;
        text-transform: uppercase;
        font-weight: normal;
      }
    }

    .ob-table-inner.tb_showMore:before {
      display: none;
    }

    th {
      .td-container {
        word-break: break-word;
      }
    }

    td {
      .td-container {
        min-height: 75px!important;
      }
    }

    td:last-child {
      opacity: 0;
      transition: opacity 0.2s;
      .td-container {
        justify-content: flex-end;
      }
    }

    tr {
      &:hover {
        td:last-child {
          opacity: 1;
        }
      }
      &.--disabled {
        background-color: $gray-200!important;
        cursor: not-allowed;
        td:last-child {
          opacity: 0!important;
        }
        .td-container {
          color: $color-grey-span;
        }
      }
    }

    .participant-booking {
      display: flex;
      align-items: center;
      @include font-mixin(11px, 20px, 400, $color-green-light, 0.4px, uppercase);
      span {
        margin-left: 7px;
      }
      &::before {
        content: '';
        position: absolute;
        top: 0;
        left: 0;
        display: block;
        width: 4px;
        height: 100%;
        background-color: $color-green-light;
      }
    }
    .participant-auction {
      @include font-mixin(11px, 20px, 400, $light-raspberry-red, 0.4px, uppercase);
    }

    .participant-name {
      @include font-mixin(11px, 20px, 400, $color-grey-label, 0.4px, uppercase);
    }

    .cancel-executor-block {
      display: flex;
      margin-bottom: 20px;
      padding: 20px;
      background-color: $color-white-lilac;
      i {
        margin-right: 20px;
        font-size: 24px;
        color: $color-blue-navy-blue;
      }
      p {
        @include font-mixin(14px, 20px, 400, $color-text-base, 0.2px);
      }
    }
    .cancel-executor-button {
      display: flex;
      align-items: center;
      border: none;
      background-color: transparent;
      outline: none;
      i {
        color: $color-grey-span;
        font-size: 14px;
      }
    }
  }
</style>
